#include <stdio.h>
#include "libpartest.h"

int run_main(int argc, char **argv)
{
	/* Call the mclInitializeApplication routine. Make sure that the application
	 * was initialized properly by checking the return status. This initialization
	 * has to be done before calling any MATLAB API's or MATLAB Compiler generated
	 * shared library functions.  */
	if( !mclInitializeApplication(NULL,0) )
	{
		fprintf(stderr, "Could not initialize the application.\n");
		return -1;
	}

	/* Call the library intialization routine and make sure that the
	 * library was initialized properly. */
	if (!libpartestInitialize()){
		fprintf(stderr,"Could not initialize the library.\n");
		return -2;
	}
	else
	{
		mlfParallel();
		/* Call the library termination routine */
		libpartestTerminate();

		/* Free the memory created */
		/*mxDestroyArray(database_dir); database_dir = 0;
		mxDestroyArray(test_dir); test_dir = 0;

		mxDestroyArray(C); C = 0;
		mxDestroyArray(Ctest); Ctest = 0;

		mxDestroyArray(F); F = 0;
		mxDestroyArray(Ftest); Ftest = 0;

		mxDestroyArray(pc); pc = 0;*/
	}

	/* Note that you should call mclTerminate application at the end of
	 * your application.
	 */
	mclTerminateApplication();
	return 0;
}

int main()
{
	mclmcrInitialize();
	return mclRunMain((mclMainFcnType)run_main,0,NULL);
}
